// ======================================================================== 
//	DragManagerModule.c			 1994 Gregory H. Dow. All rights reserved. 
// ======================================================================== 

#ifndef __DRAG__
#include <Drag.h>
#endif

#ifndef __WINDOWS__
#include <Windows.h>
#endif

typedef OSErr (*DragItemReceiveFunc)(WindowRef, DragReference, ItemReference);

typedef struct	DragInfoRecord {
	WindowPtr				window;
	FlavorType				flavor;
	RgnHandle				receiveRgn;
	DragItemReceiveFunc		receiveFunc;
	DragTrackingHandlerUPP	dragTrackingProc;
	DragReceiveHandlerUPP	dragReceiveProc;
} DragInfoRecord, **DragInfoHandle;


void 	AdjustDragRgn(void);
Boolean	IsDragManagerInstalled(void);
OSErr	InitDragInfo(DragInfoHandle dragInfo);
void	KillDragInfo(DragInfoHandle dragInfo);
OSErr	ReceiveHFSDrag(WindowRef, DragReference, ItemReference);

Boolean HandleDragSelection(EventRecord *, RgnHandle);


